/******************************************************************************

	COPYRIGHT(C) JONAS 'SORTIE' TERMANSEN 2011.

	This file is part of Sortix.

	Sortix is free software: you can redistribute it and/or modify it under the
	terms of the GNU General Public License as published by the Free Software
	Foundation, either version 3 of the License, or (at your option) any later
	version.

	Sortix is distributed in the hope that it will be useful, but WITHOUT ANY
	WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
	FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
	details.

	You should have received a copy of the GNU General Public License along
	with Sortix. If not, see <http://www.gnu.org/licenses/>.

	memory.h
	Useful functions for manipulating memory.

******************************************************************************/

#ifndef LIBMAXSI_MEMORY_H
#define LIBMAXSI_MEMORY_H

namespace LibMaxsi
{
	namespace Memory
	{
		inline void Copy(void* Dest, void* Src, size_t Length)
		{
			char* D = (char*) Dest; char* S = (char*) Src;

			for ( size_t I = 0; I < Length; I++ )
			{
				D[I] = S[I];
			}
		}

		inline void Set(void* Dest, int Value, size_t Length)
		{
			byte* D = (byte*) Dest;

			for ( size_t I = 0; I < Length; I++ )
			{
				D[I] = Value & 0xFF;
			}
		}
	}
}

#endif

